<?php

/**
 * inf_prenomina_detalle_retro actions.
 *
 * @package    nomina
 * @subpackage inf_prenomina_detalle_retro
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_prenomina_detalle_retroActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc, id_periodo_ajuste, CODIGO ';
        }



        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $num_doc = $request['num_doc'];
            $id_tipo_doc = $request['id_tipo_doc'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //centro operacion
            if (isset($request['id_cen_op'])) {
                $whereCenOpe = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOpe = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 
per.periodo,
liquida.id_tipo_doc,
liquida.num_doc,
liquida.id_periodo,
liquida.num_dias as dias, 
concep.codigo as codigo, 
concep.descripcion as descripcion , 
case when concep.id_tipo_concepto = 1 then liquida.valor_liquidado else 0 end as valor_dev, 
case when concep.id_tipo_concepto != 1 then liquida.valor_liquidado else 0 end as VALOR_ded

FROM no_liquida_nomina liquida

left join no_concep_nomina concep ON concep.id_concep_nomina = liquida.id_concep_nomina

left join no_periodo_v per on per.id_periodo = liquida.id_periodo_ajuste                   
                    
where 
liquida.num_doc = $num_doc 
and liquida.id_tipo_doc = $id_tipo_doc     
and liquida.id_periodo = $periodo_filtro    

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
    
select 
per.periodo,
liquida.id_tipo_doc,
liquida.num_doc,
liquida.id_periodo,
liquida.num_dias as dias, 
concep.codigo as codigo, 
concep.descripcion as descripcion , 
case when concep.id_tipo_concepto = 1 then liquida.valor_liquidado else 0 end as valor_dev, 
case when concep.id_tipo_concepto != 1 then liquida.valor_liquidado else 0 end as VALOR_ded

FROM no_liquida_nomina liquida

left join no_concep_nomina concep 
ON concep.id_concep_nomina = liquida.id_concep_nomina

left join no_periodo_v per on per.id_periodo = liquida.id_periodo_ajuste     

where 
liquida.num_doc = $num_doc 
and liquida.id_tipo_doc = $id_tipo_doc     
and liquida.id_periodo = $periodo_filtro 

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_prenomina_detalle] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

    /**
     * Metodo para sumar 
     *
     * @param sfWebRequest $request
     */
    public function executeSum(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc, CODIGO ';
        }

        //manejo de errores
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $num_doc = $request['num_doc'];
            $id_tipo_doc = $request['id_tipo_doc'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //centro operacion
            if (isset($request['id_cen_op'])) {
                $whereCenOpe = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCenOpe = ' ';
            }


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT

   'TOTALES' as codigo,

   SUM(valor_dev)  as valor_dev,
   SUM(valor_ded)  as valor_ded

FROM (   

select 
liquida.id_tipo_doc,
liquida.num_doc,
liquida.id_periodo,
liquida.num_dias as dias, 
concep.codigo as codigo, 
concep.descripcion as descripcion , 
case when concep.id_tipo_concepto = 1 then liquida.valor_liquidado else 0 end as valor_dev, 
case when concep.id_tipo_concepto != 1 then liquida.valor_liquidado else 0 end as VALOR_ded

FROM no_liquida_nomina liquida

left join no_concep_nomina concep 
ON concep.id_concep_nomina = liquida.id_concep_nomina

where 
liquida.num_doc = $num_doc 
and liquida.id_tipo_doc = $id_tipo_doc     
and liquida.id_periodo = $periodo_filtro 

$sortBy

)

EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = count($resultado);
            $this->startRow = 0;
            $this->endRow = count($resultado);
            $this->list_data = $resultado;
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}

